Attribute VB_Name = "mMisc"
Option Explicit

Public Type LARGE_INTEGER
    LowPart As Long
    HighPart As Long
End Type

Public Type SYSTEMTIME
   wYear As Integer
   wMonth As Integer
   wDayOfWeek As Integer
   wDay As Integer
   wHour As Integer
   wMinute As Integer
   wSecond As Integer
   wMilliseconds As Integer
End Type

Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Public Declare Function StrFormatByteSize Lib "Shlwapi" Alias "StrFormatByteSizeW" (ByVal dw As Currency, ByVal pszBuf As Long, ByVal cchBuf As Long) As Long
Public Declare Function FileTimeToSystemTime Lib "kernel32" (lpFileTime As LARGE_INTEGER, lpSystemTime As SYSTEMTIME) As Long
Public Declare Function FileTimeToLocalFileTime Lib "kernel32" (lpFileTime As LARGE_INTEGER, lpLocalFileTime As LARGE_INTEGER) As Long
Private Declare Function lstrlenW Lib "kernel32" (ByVal lpString As Long) As Long

Public Function TrimNull(startstr As String) As String
   Dim pos As Integer
   pos = InStr(startstr, Chr$(0))
   If pos Then
      TrimNull = Left$(startstr, pos - 1)
      Exit Function
   End If
   TrimNull = startstr
End Function

Public Function FormatByteSize(ByVal Bytes As Currency) As String
   Dim strBuff As String * 256
   Dim nRet As Long
   nRet = StrFormatByteSize(Bytes / 10000, StrPtr(strBuff), 256)
   If nRet Then FormatByteSize = Ptr2StrU(nRet)
End Function

Public Function ZeroPad(ByVal s As String, n As Long) As String
    ZeroPad = Right(String(n, "0") & s, n)
End Function

Public Function Ptr2StrU(ByVal pAddr As Long, Optional dwSize As Long) As String
   If pAddr = 0 Then Exit Function
   If dwSize = 0 Then dwSize = lstrlenW(pAddr)
   Ptr2StrU = Space$(dwSize)
   CopyMemory ByVal StrPtr(Ptr2StrU), ByVal pAddr, dwSize * 2
End Function

Public Function FileTimeToVBTime(ByVal value As Variant) As Date
    Dim st As SYSTEMTIME
    Dim ft As LARGE_INTEGER
    Dim curTemp As Currency
    Select Case TypeName(value)
           Case vbCurrency
               curTemp = CCur(value)
           Case Else
               curTemp = CCur(value / 10000)
    End Select
    CopyMemory ft, curTemp, 8
    FileTimeToLocalFileTime ft, ft
    Call FileTimeToSystemTime(ft, st)
    FileTimeToVBTime = TimeSerial(st.wHour, st.wMinute, st.wSecond)
End Function
