Attribute VB_Name = "mPerf"

Public Type COUNTERS_ID
   Process                      As String
   Processor_Time               As String
   User_Time                    As String
   Privileged_Time              As String
   Virtual_Bytes_Peak           As String
   Virtual_Bytes                As String
   Page_Faults_per_sec          As String
   Working_Set_Peak             As String
   Working_Set                  As String
   Page_File_Bytes_Peak         As String
   Page_File_Bytes              As String
   Private_Bytes                As String
   Thread_Count                 As String
   Priority_Base                As String
   Elapsed_Time                 As String
   ID_Process                   As String
   Creating_Process_ID          As String
   Pool_Paged_Bytes             As String
   Pool_Nonpaged_Bytes          As String
   Handle_Count                 As String
   IO_Read_Operations_per_sec   As String
   IO_Write_Operations_per_sec  As String
   IO_Data_Operations_per_sec   As String
   IO_Other_Operations_per_sec  As String
   IO_Read_Bytes_per_sec        As String
   IO_Write_Bytes_per_sec       As String
   IO_Data_Bytes_per_sec        As String
   IO_Other_Bytes_per_sec       As String
End Type

Public counters As COUNTERS_ID
Dim bInit As Boolean
Public g_colCounters As Collection

Public Function InitCounters(Optional bForce As Boolean) As Boolean
   If bForce Then bInit = False
   If bInit Then
      InitCounters = True
      Exit Function
   End If
   Dim hKey As Long, lType As Long, dwSize As Long, ret As Long, i As Long
   Dim abData() As Byte
   Dim s As String
   Dim sVal() As String
   
   ret = RegOpenKeyEx(HKEY_LOCAL_MACHINE, PerfLibKey, 0, KEY_READ, hKey)
   If hKey = 0 Then Exit Function
   
   RegQueryValueEx hKey, "Counter", 0, lType, 0, dwSize
   If dwSize Then
      ReDim abData(dwSize - 1)
      RegQueryValueEx hKey, "Counter", 0, lType, abData(0), dwSize
      s = StrConv(abData, vbUnicode)
      sVal = Split(s, Chr(0))
      Set g_colCounters = Nothing
      Set g_colCounters = New Collection
      For i = 2 To UBound(sVal) - 2 Step 2
          g_colCounters.Add sVal(i + 1), sVal(i)
          Select Case Trim(sVal(i + 1))
             Case "Process":                 counters.Process = sVal(i)
             Case "% Processor Time":        counters.Processor_Time = sVal(i)
             Case "% User Time":             counters.User_Time = sVal(i)
             Case "% Privileged Time":       counters.Privileged_Time = sVal(i)
             Case "Virtual Bytes Peak":      counters.Virtual_Bytes_Peak = sVal(i)
             Case "Virtual Bytes":           counters.Virtual_Bytes_Peak = sVal(i)
             Case "Page Faults / sec":       counters.Page_Faults_per_sec = sVal(i)
             Case "Working Set Peak":        counters.Working_Set_Peak = sVal(i)
             Case "Working Set":             counters.Working_Set = sVal(i)
             Case "Page File Bytes Peak":    counters.Page_File_Bytes_Peak = sVal(i)
             Case "Page File Bytes":         counters.Page_File_Bytes = sVal(i)
             Case "Private Bytes":           counters.Private_Bytes = sVal(i)
             Case "Thread Count":            counters.Thread_Count = sVal(i)
             Case "Priority Base":           counters.Priority_Base = sVal(i)
             Case "Elapsed Time":            counters.Elapsed_Time = sVal(i)
             Case "ID Process":              counters.ID_Process = sVal(i)
             Case "Creating Process ID":     counters.Creating_Process_ID = sVal(i)
             Case "Pool Paged Bytes":        counters.Pool_Paged_Bytes = sVal(i)
             Case "Pool Nonpaged Bytes":     counters.Pool_Nonpaged_Bytes = sVal(i)
             Case "Handle Count":            counters.Handle_Count = sVal(i)
             Case "IO Read Operations/sec":  counters.IO_Read_Operations_per_sec = sVal(i)
             Case "IO Write Operations/sec": counters.IO_Write_Operations_per_sec = sVal(i)
             Case "IO Data Operations/sec":  counters.IO_Data_Operations_per_sec = sVal(i)
             Case "IO Other Operations/sec": counters.IO_Other_Operations_per_sec = sVal(i)
             Case "IO Read Bytes/sec":       counters.IO_Read_Bytes_per_sec = sVal(i)
             Case "IO Write Bytes/sec":      counters.IO_Write_Bytes_per_sec = sVal(i)
             Case "IO Data Bytes/sec":       counters.IO_Data_Bytes_per_sec = sVal(i)
             Case "IO Other Bytes/sec":      counters.IO_Other_Bytes_per_sec = sVal(i)
             Case Else
          End Select
      Next i
   End If
   RegCloseKey hKey
End Function

Public Function GetPerfData(ByVal idx As Long) As Byte()
   
   Dim hKey As Long, lType As Long, dwSize As Long, ret As Long
   Dim abData() As Byte
   ReDim abData(0)
   lType = REG_BINARY
   
   Do While RegQueryValueEx(HKEY_PERFORMANCE_DATA, CStr(idx), 0, lType, abData(0), dwSize) = ERROR_MORE_DATA
      dwSize = dwSize + 100000
      ReDim abData(dwSize - 1)
      If dwSize > 1000000 Then Exit Do
   Loop
   Call RegCloseKey(HKEY_PERFORMANCE_DATA)
   GetPerfData = abData
   Erase abData
End Function

