Attribute VB_Name = "mPerfCounters"
Option Explicit

Public Type PerfData
   CounterId As Long
   CounterName As String
End Type

Public pdAll() As PerfData
Public pdGlobal() As PerfData
Public pdCostly() As PerfData
Dim bAllInit As Boolean
Dim bGlobalInit As Boolean
Dim bCostlyInit As Boolean

Public Function InitAllCounters(colCounters As Collection, colHelp As Collection, _
                                Optional bForce As Boolean) As Boolean
   If bForce Then bAllInit = False
   If bAllInit Then
      InitAllCounters = True
      Exit Function
   End If
   Dim hKey As Long, lType As Long, dwSize As Long, ret As Long, i As Long
   Dim abData() As Byte
   Dim s As String
   Dim sVal() As String
   
   ret = RegOpenKeyEx(HKEY_LOCAL_MACHINE, PerfLibKey, 0, KEY_READ, hKey)
   If hKey = 0 Then Exit Function
   
   Set colHelp = Nothing
   Set colCounters = Nothing
   Set colHelp = New Collection
   Set colCounters = New Collection
   
   RegQueryValueEx hKey, "Counter", 0, lType, 0, dwSize
   If dwSize Then
      ReDim abData(dwSize - 1)
      RegQueryValueEx hKey, "Counter", 0, lType, abData(0), dwSize
      s = StrConv(abData, vbUnicode)
      sVal = Split(s, Chr(0))
      ReDim pdAll((UBound(sVal) - 1) / 2 - 2)
      For i = 2 To UBound(sVal) - 2 Step 2
          pdAll(i / 2 - 1).CounterId = sVal(i)
          pdAll(i / 2 - 1).CounterName = sVal(i + 1)
          colCounters.Add sVal(i + 1), sVal(i)
      Next i
   End If
   RegQueryValueEx hKey, "Help", 0, lType, 0, dwSize
   If dwSize Then
      ReDim abData(dwSize - 1)
      RegQueryValueEx hKey, "Help", 0, lType, abData(0), dwSize
      s = StrConv(abData, vbUnicode)
      sVal = Split(s, Chr(0))
      For i = 0 To UBound(sVal) - 2 Step 2
          colHelp.Add sVal(i + 1), CStr(sVal(i) - 1)
      Next i
   End If
   RegCloseKey hKey
   bAllInit = True
   InitAllCounters = True
End Function

Public Function InitGlobalCounters(colCounters As Collection, _
                                   Optional bForce As Boolean) As Boolean
   
   If bForce Then bGlobalInit = False
   If bGlobalInit Then
      InitGlobalCounters = True
      Exit Function
   End If
   
   If colCounters.Count = 0 Then Exit Function
   
   Dim pdb As PERF_DATA_BLOCK
   Dim pot() As PERF_OBJECT_TYPE
   Dim nObjects As Long, lpOffset As Long, i As Long
   Dim abData() As Byte
   Dim s As String
   
   abData = GetPerfData("Global", 50000)

   CopyMemory pdb, abData(0), Len(pdb)
   If pdb.HeaderLength = 0 Then Exit Function
   nObjects = pdb.NumObjectTypes
   If nObjects = 0 Then Exit Function
   ReDim pdGlobal(nObjects - 1)
   ReDim pot(nObjects - 1)
   lpOffset = pdb.HeaderLength
   For i = 0 To nObjects - 1
       CopyMemory pot(i), abData(lpOffset), LenB(pot(0))
       s = CStr(pot(i).ObjectNameTitleIndex)
       On Error Resume Next
       s = colCounters(s)
       If Err Then s = "Counter ID = " & s
       On Error GoTo 0
       pdGlobal(i).CounterId = pot(i).ObjectNameTitleIndex
       pdGlobal(i).CounterName = s
       lpOffset = lpOffset + pot(i).TotalByteLength
   Next i
   bGlobalInit = True
   InitGlobalCounters = True
End Function

Public Function InitCostlyCounters(colCounters As Collection, _
                                   Optional bForce As Boolean) As Boolean
   
   If bForce Then bCostlyInit = False
   If bCostlyInit Then
      InitCostlyCounters = True
      Exit Function
   End If
   
   If colCounters.Count = 0 Then Exit Function
'   MsgBox "Costly data require some time to proceed (up to 1 minute)." & vbCrLf & "Be patient...", vbExclamation, "Note"
   
   Dim pdb As PERF_DATA_BLOCK
   Dim pot() As PERF_OBJECT_TYPE
   Dim nObjects As Long, lpOffset As Long, i As Long
   Dim abData() As Byte
   Dim s As String
   
   abData = GetPerfData("Costly", 200000)

   CopyMemory pdb, abData(0), Len(pdb)
   If pdb.HeaderLength = 0 Then Exit Function
   nObjects = pdb.NumObjectTypes
   If nObjects = 0 Then Exit Function
   ReDim pdCostly(nObjects - 1)
   ReDim pot(nObjects - 1)
   lpOffset = pdb.HeaderLength
   For i = 0 To nObjects - 1
       CopyMemory pot(i), abData(lpOffset), LenB(pot(0))
       s = CStr(pot(i).ObjectNameTitleIndex)
       On Error Resume Next
       s = colCounters(s)
       If Err Then s = "Counter ID = " & s
       On Error GoTo 0
       pdCostly(i).CounterId = pot(i).ObjectNameTitleIndex
       pdCostly(i).CounterName = s
       lpOffset = lpOffset + pot(i).TotalByteLength
   Next i
   bCostlyInit = True
   InitCostlyCounters = True
End Function

Public Function GetPerfData(ByVal idx As String, _
                            Optional ByVal dwGrow As Long = 100000) As Byte()
   
   Dim hKey As Long, lType As Long, dwSize As Long
   Dim abData() As Byte
   
   lType = REG_BINARY
   dwSize = dwGrow
   ReDim abData(dwSize - 1)
   
   Do While RegQueryValueEx(HKEY_PERFORMANCE_DATA, idx, 0, lType, abData(0), dwSize) = ERROR_MORE_DATA
      dwSize = dwSize + dwGrow
      ReDim abData(dwSize - 1)
      If dwSize > &HFFFFFF Then Exit Do
   Loop
   Call RegCloseKey(HKEY_PERFORMANCE_DATA)
   ReDim Preserve abData(dwSize - 1)
   GetPerfData = abData
   Erase abData
End Function
